<ui:composition
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns="http://www.w3.org/1999/xhtml">
    <script>
        function updateMessage() {
            if (document
                            .getElementById("globalform:assertionIdDecoration:assertionIdInput").value == "") {
                document
                        .getElementById("globalform:assertionIdDecoration:assertionIdInputAlreadyUsed").textContent = "";
            }
        }
        function cleanUpPredicate() {
            var predicate = $("textarea");
            predicate.val(predicate.val().replace(/[^\u0020-\u007E|\u00A1-\u0160]/g, ""));
        }


    </script>
    <h:form id="globalform" rendered="#{identity.loggedIn}">

        <s:token allowMultiplePosts="true"/>
        <div class="col-lg-5 col-md-6">
            <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                <ui:define name="panel_title">
                    <h:outputText
                            value="#{title}"/>
                </ui:define>
                <s:decorate id="idSchemeDecoration" template="/layout/form/_edit.xhtml">
                    <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.IdScheme']}</ui:define>
                    <ui:param name="id"
                              value="idSchemeListBox"/>
                    <h:selectOneMenu id="idSchemeListBox" styleClass="form-control"
                                     value="#{assertionManager.selectedAssertion.target}"
                                     requiredMessage="Please select an id Scheme" required="true">
                        <f:selectItem itemValue="#{null}"
                                      itemLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                        <f:selectItems value="#{assertionManager.getTargets()}"
                                       var="target" itemLabel="#{target.idScheme}"
                                       itemValue="#{target.id}"/>
                        <a4j:ajax event="change" render="globalform,documentForm"
                                  execute="@this"
                                  listener="#{assertionManager.updateOasisTarget()}"/>
                    </h:selectOneMenu>
                </s:decorate>

                <s:div id="newDocument" styleClass="col-md-offset-1 col-md-11"
                       rendered="#{not empty assertionManager.selectedAssertion.target.idScheme and empty assertionManager.selectedAssertion.normativeSource}">
                    <ui:decorate template="/layout/panels/_panel_title.xhtml">
                        <ui:param name="styleClass" value="panel-info"/>
                        <ui:define name="panel_title">
                            This idScheme has no document linked
                        </ui:define>
                        <s:decorate id="docDecoration"
                                    template="/layout/form/_edit.xhtml">
                            <ui:param name="id"
                                      value="globalform:docDecoration:docListBox"/>
                            <ui:define name="label">Link a document to the IdScheme
                            </ui:define>
                            <h:selectOneMenu id="docListBox"
                                             styleClass="form-control"
                                             value="#{assertionManager.newDocument}"
                                             requiredMessage="Please select an idScheme document" required="true">
                                <f:selectItem itemValue="#{null}"
                                              itemLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                                <f:selectItems
                                        value="#{assertionManager.getDocuments()}"/>
                                <a4j:ajax event="change" render="documentForm"
                                          execute="@this"/>

                            </h:selectOneMenu>
                        </s:decorate>
                    </ui:decorate>
                </s:div>

                <s:decorate id="assertionIdDecoration"
                            template="/layout/form/_edit.xhtml">
                    <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.AssertionId']}</ui:define>
                    <ui:param name="id"
                              value="globalform:assertionIdDecoration:assertionIdInput"/>
                    <div class="input-group">
                        <h:inputText id="assertionIdInput" styleClass="form-control"
                                     value="#{assertionManager.selectedAssertion.assertionId}"
                                     requiredMessage="Please fill in the Assertion Id"
                                     required="true">
                            <a4j:ajax event="blur" render="assertionIdDecoration"
                                      listener="#{assertionManager.validateAssertionId()}"
                                      oncomplete="updateMessage();" execute="@this"/>
                        </h:inputText>
                        <s:span
                                rendered="#{not invalid and empty assertionManager.selectedAssertion.assertionId}"
                                styleClass="input-group-addon">
                        </s:span>
                        <s:span
                                rendered="#{not invalid and not empty assertionManager.selectedAssertion.assertionId}"
                                styleClass="input-group-addon">
                            <i class="fa fa-check"/>
                        </s:span>
                        <s:span id="assertionIdInputAlreadyUsed" rendered="#{invalid}"
                                styleClass="input-group-addon">
                            <i class="fa fa-exclamation-triangle"/>
                            <h:outputText value=" #{messages['net.ihe.gazelle.assertion-manager.AlreadyUsed']}"/>
                        </s:span>
                    </div>

                </s:decorate>
                <s:decorate id="predicateDecoration" template="/layout/form/_edit.xhtml">
                    <ui:param name="id"
                              value="globalform:predicateDecoration:predicate"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Predicate']}</ui:define>
                    <h:inputTextarea rows="4" cols="160" required="true"
                                     requiredMessage="Please fill in the predicate"
                                     id="predicate" styleClass="form-control" onblur="cleanUpPredicate();"
                                     value="#{assertionManager.selectedAssertion.predicate.content}">
                    </h:inputTextarea>
                </s:decorate>
                <s:decorate id="prescriptionLevelDecoration"
                            template="/layout/form/_edit.xhtml">
                    <ui:param name="id"
                              value="globalform:prescriptionLevelDecoration:prescriptionLevelListBox"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.PrescriptionLevel']}
                    </ui:define>
                    <h:selectOneMenu id="prescriptionLevelListBox"
                                     styleClass="form-control"
                                     value="#{assertionManager.selectedAssertion.prescription.level}"
                                     requiredMessage="Please select a prescription level" required="true">
                        <f:selectItem itemValue="#{null}"
                                      itemLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                        <f:selectItems
                                value="#{assertionManager.getPrescriptionLevels()}"/>
                        <a4j:ajax event="blur" render="prescriptionLevelDecoration"
                                  execute="@this"/>
                    </h:selectOneMenu>
                </s:decorate>

                <a4j:repeat value="#{assertionManager.selectedAssertion.tags}"
                            var="tag">
                    <s:div id="pageDiv" rendered="#{tag.name == 'Page'}">
                        <s:decorate id="pageEdit" template="/layout/form/_edit.xhtml">
                            <ui:define name="label">#{tag.name}</ui:define>
                            <ui:param name="id" value="globalform:pageDiv:pageEdit:#{tag.name}"/>
                            <h:inputText id="Page" value="#{tag.content}" styleClass="form-control"
                                         requiredMessage="Please fill in the page"
                                         required="true">
                                <a4j:ajax event="change" disabled="#{tag.name == 'Section'}"
                                          render="documentForm" execute="@this"/>
                            </h:inputText>
                        </s:decorate>
                    </s:div>
                    <s:div rendered="#{tag.name != 'Page'}">
                        <s:decorate>
                            <div class="form-group  #{invalid?'has-error':''}">
                                <label>
                                    Type *
                                    <h:selectOneMenu id="ltaglst" requiredMessage="Please select a tag value"
                                                     required="true"
                                                     styleClass="form-control" style="display: inline; width: 70%;"
                                                     value="#{tag.name}">
                                        <f:selectItem itemValue=""
                                                      itemLabel="#{messages['gazelle.common.button.ShowAll']}*"/>
                                        <f:selectItems value="#{assertionManager.getTagKeywords()}"/>
                                    </h:selectOneMenu>
                                </label>

                                <s:validateAll>
                                    <h:inputText value="#{tag.content}" styleClass="form-control"
                                                 requiredMessage="Please fill in the tag value"
                                                 required="true">
                                    </h:inputText>
                                </s:validateAll>
                            </div>
                        </s:decorate>
                    </s:div>
                </a4j:repeat>

                <s:decorate id="statusDecoration" template="/layout/form/_edit.xhtml">
                    <ui:param name="id"
                              value="globalform:statusDecoration:statusListBox"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Status']}</ui:define>
                    <h:selectOneMenu id="statusListBox" styleClass="form-control"
                                     value="#{assertionManager.selectedAssertion.status}"
                                     requiredMessage="Please select a status value" required="true">
                        <f:selectItem itemValue="#{null}"
                                      itemLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                        <f:selectItems value="#{assertionManager.getAssertionStatus()}"/>
                        <a4j:ajax event="blur" render="statusDecoration" execute="@this"/>
                    </h:selectOneMenu>
                </s:decorate>

                <s:decorate template="/layout/form/_checkbox.xhtml">
                    <h:selectBooleanCheckbox value="#{assertionManager.selectedAssertion.testable}"/>
                    Testable
                    <ui:define name="help">
                        <ui:decorate template="/layout/popover/_popover_on_icon.xhtml">
                            <ui:param name="id" value="testableQuestion"/>
                            <ui:param name="icon_class" value="gzl-icon-question-circle"/>
                            <ui:param name="placement" value="right"/>
                            <ui:param name="trigger" value="click"/>
                            <ui:define name="content">
                                <h:outputText styleClass="help-block"
                                              value="Checked, assertion can be covered. It will count in coverage statistics"/>
                                <h:outputText styleClass="help-block"
                                              value="Unchecked, the assertion is not testable then it wont appear in the covered by section. It wont count in coverage statistics"/>
                            </ui:define>
                        </ui:decorate>
                    </ui:define>
                </s:decorate>
                <ui:define name="panel_footer">
                    <a4j:commandButton id="SaveButton"
                                       action="#{assertionManager.saveAssertion()}"
                                       value="#{messages['gazelle.simulator.Save']}"
                                       execute="globalform" render="globalform"
                                       styleClass="gzl-btn-blue"/>

                    <a4j:commandButton id="SaveAndNewButton" render="globalform"
                                       action="#{assertionManager.saveAssertionAndCreateNewOne()}"
                                       value="#{messages['gazelle.simulator.Save']} #{messages['net.ihe.gazelle.assertion-manager.AndNew']}"
                                       styleClass="gzl-btn-blue" execute="globalform"/>

                    <h:outputLink value="index.seam" rendered="#{s:hasRole('admin_role')}" styleClass="gzl-btn">
                        #{messages['users.Cancel']}
                    </h:outputLink>

                    <a4j:commandButton
                            styleClass="gzl-btn-red"
                            oncomplete="jq162('#DeleteAssertionConfirmationModalPanel').modal('show');"
                            actionListener="#{assertionManager.setAssertionToDelete(assertionManager.getSelectedAssertion())}"
                            immediate="true"
                            rendered="#{identity.loggedIn and assertionManager.getSelectedAssertion().getId() != null}"
                            value="#{messages['users.Delete']}" render="assertionFrom"/>
                </ui:define>
            </ui:decorate>
        </div>
    </h:form>
    <div class="col-lg-7 col-md-6">
        <h:form id="documentForm" rendered="#{identity.loggedIn}">
            <s:div id="documentPdf"
                   rendered="#{not empty assertionManager.selectedAssertion.normativeSource}">
                <iframe height="1100" scrolling="no" width="100%" id="pdfjs"
                        src="#{request.contextPath}/pdfjs/web/viewer.html?file=#{request.contextPath}/documents/getPDFdocument.seam%3Furl%3D#{assertionManager.selectedAssertion.getUri()}#page=#{assertionManager.selectedAssertion.getTestAssertionPageNumber()}"></iframe>
            </s:div>
            <s:div id="documentPdf_preview"
                   rendered="#{empty assertionManager.selectedAssertion.normativeSource and not empty assertionManager.getNewDocument().getEncodedUri()}">
                <iframe height="1100" scrolling="no" width="100%" id="pdfjs"
                        src="#{request.contextPath}/pdfjs/web/viewer.html?file=#{request.contextPath}/documents/getPDFdocument.seam%3Furl%3D#{assertionManager.getNewDocument().getEncodedUri()}#page=#{assertionManager.selectedAssertion.getTestAssertionPageNumber()}"></iframe>
            </s:div>
        </h:form>
    </div>

    <h:form id="deleteAssertionForm">
        <s:token allowMultiplePosts="true"/>
        <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
            <ui:param name="popup_id" value="DeleteAssertionConfirmationModalPanel"/>
            <ui:define name="popup_title">
                <h:outputText
                        value="#{messages['net.ihe.gazelle.assertion-manager.ConfirmDelete']}"/>
            </ui:define>
            <h:outputText id="currentAssertion_DeleteOutputText"
                          value="#{messages['net.ihe.gazelle.assertion-manager.DoYouReallyWantToDeleteThisAssertion']} #{assertionManager.getAssertionToDelete().getAssertionId()}?"/>


            <ui:define name="popup_footer">
                <h:commandButton value="#{messages['users.Cancel']}"
                                 styleClass="gzl-btn"
                                 onclick="jq162('#DeleteAssertionConfirmationModalPanel').modal('hide');"/>

                <h:commandButton value="#{messages['users.Delete']}" action="#{assertionManager.delete()}"
                                 styleClass="gzl-btn-red"
                                 onclick="jq162('#DeleteAssertionConfirmationModalPanel').modal('hide');history.go(#{assertionManager.getBackTo()})"/>
            </ui:define>
        </ui:decorate>
    </h:form>
</ui:composition>